namespace CMSMicroservice.Application.NetworkMembershipCQ.Queries.GetNetworkMembershipHistory;

public class GetNetworkMembershipHistoryQueryValidator : AbstractValidator<GetNetworkMembershipHistoryQuery>
{
    public GetNetworkMembershipHistoryQueryValidator()
    {
        RuleFor(x => x.UserId)
            .GreaterThan(0)
            .WithMessage("شناسه کاربر معتبر نیست")
            .When(x => x.UserId.HasValue);
    }

    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(
            ValidationContext<GetNetworkMembershipHistoryQuery>.CreateWithOptions(
                (GetNetworkMembershipHistoryQuery)model,
                x => x.IncludeProperties(propertyName)));

        if (result.IsValid)
            return Array.Empty<string>();

        return result.Errors.Select(e => e.ErrorMessage);
    };
}
